<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\FPA\Calculos\Geral\EventosFaltasIntervalo;
use HCM\FPA\Calculos\Geral\MediaEventosIntervalo;
use HCM\FPA\Calculos\Geral\CalendarioLogic;
use HCM\FPA\Calculos\Fechamento\Fechamento;
use HCM\FPA\Entity\FpaitecalcfolhaEntity;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Entity\FpaTpferiasvincEntity;
use HCM\FPA\Entity\FpaValorreferenciamEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpaGrpitemEntity;
use HCM\FPA\Entity\FpaVinceventoEntity;
use HCM\FPA\Entity\FpaOcupaeventoEntity;
use HCM\FPA\Entity\FpaEstruteventoEntity;
use HCM\Geral\Entity\EstruturamEntity;
use HCM\Geral\Entity\GpesiteventoEntity;
use HCM\Geral\Entity\GpealtesalarioEntity;
use HCM\Geral\Entity\GpeAlteocupacaoEntity;
use HCM\Geral\Entity\GpemovimentacaoEntity;
use HCM\Geral\Entity\GpesitufunchEntity;
use HCM\Geral\Entity\GpevinculomEntity;
use Teknisa\Model\Gestaopessoas\Entities\FpaFormresccomplementar;

abstract class CalculoAbstract {

    protected $_nrorg;
    protected $_nrOrgPadrao;
    protected $_mes_competencia;
    protected $_mes_competencia_int;
    protected $_ult_dia_mes;
    protected $_dt_pagamento;
    protected $_ultPagamento;
    protected $_simulacao;
    protected $_parcial;
    protected $_idDebug;
    protected $_id_retrocesso;
    protected $_vr_salarioDissidio;
    protected $_id_fazDifComp;
    protected $_ambiente_salario_operador;
    protected $_tp_modalidade_salario_operador;
    protected $_baseCorrespPeriodoIntegral;
    public $_nr_tipo_calculo;
    protected $_listaProcessos;
    protected $_listaDireitos;
    protected $_recalculo = false;
    protected $_salario;
    protected $_salariohora;
    protected $_tipoSalario;
    protected $_tipoAltSal;
    protected $_dataDissidio;
    protected $_dataBaseDissidio;
    protected $_dias_trabalhados;
    protected $_dias_remuneracao;
    protected $_dias_normais;
    protected $_dias_uteis;
    protected $_dias_rsr;
    protected $_dias_afastados;
    protected $_dias_ferias;
    protected $_dias_feriado;
    protected $_dias_maternidade;
    protected $_dias_uteis_ferias;
    protected $_dias_rsr_ferias;
    protected $_dias_atestados;
    protected $_jornada_diaria;
    protected $_jornada_semanal;
    protected $_sit_func_resumo = array();
    protected $_primeiroDiaAno;
    protected $_inicio_periodo;
    protected $_fim_periodo;
    protected $_dia_fecha_apuracao;
    protected $_ini_periodo_apura;
    protected $_fim_periodo_apura;
    protected $_fechamento;
    protected $_pessoa;
    protected $_pessoah;
    protected $_vinculo;
    protected $_nrTpVinculoAnterior;
    protected $_escalam;
    protected $_situacao_funcional;
    protected $_alteracao_situacao_funcional;
    protected $_alteracaoSalario;
    protected $_alteracaoOcupacao;
    protected $_movimentosVinculo;
    protected $escalaVinculo;
    protected $_tipo_calculo;
    protected $_obj_tipo_calculo;
    protected $_tpCalcMov;
    protected $_nrTipoModalidadeCalculo;
    protected $_nrOcorrenciaCalculo;
    protected $_movimentoPrincipal;
    protected $_movimentoAuxiliar;
    protected $_gruposCalulos;
    protected $_itens_calculo_principal;
    protected $_itens_salario_maternidade;
    protected $_itens_adiantamento_demonstra;
    protected $_itens_adiantamento_ma;
    protected $_itens_ferias_mc;
    protected $_itens_ferias_ma;
    protected $_itens_ferias_maa;
    protected $_itens_provisao_mes_anterior;
    protected $_itens_aviso_previo;
    protected $_itens_ferias_vencidas_rescisao;
    protected $_itens_ferias_proporcionais_rescisao;
    protected $_itens_13sal_resc;
    protected $_itens_13sal_demonstra;
    protected $_itens_origem;
    protected $_itens_media_mensal;
    protected $_media;
    protected $_valores_referencia;
    protected $_dtInicioGozo;
    protected $_dtFimGozo;
    protected $_ferias;
    protected $_gozo_ferias;
    protected $_tpFeriasVinc;
    protected $_demonstraFeriasResumo = array();
    protected $_faltas_intervalo;
    protected $_eventomMedia;
    protected $_eventom;
    protected $_eventoRelacionado;
    protected $_assoc_eventos;
    protected $_sit_evento;
    protected $_itemGrupo;
    protected $_vincEvento;
    protected $_ocupacaoEvento;
    protected $_estruturaEvento;
    protected $_regram;
    protected $_calculo_regra;
    protected $_tpCalcRegra;
    protected $_estrutura;
    protected $_paramCalculo;
    protected $_idTipoArredonda;
    protected $_nrDigitoArredonda;
    protected $_nrLimiteArredonda;
    protected $_nrGrupoIncidencia;
    protected $_nrControleAdmissao;
    protected $_idIRAcumulaRecMinimo;
    protected $_percentualAdiantamento;
    protected $_nrDiasMinAdiantamento;
    protected $_idRecAdianPriMes;
    protected $_nrControleFerias;
    protected $_nrControleAfastamento;
    protected $_vrEnc1Ferias;
    protected $_vrEnc2Ferias;
    protected $_vrEnc1Aviso;
    protected $_vrEnc2Aviso;
    protected $_vrEnc1DecTerceiro;
    protected $_vrEnc2DecTerceiro;
    protected $_vrPercentualProvisao;
    protected $_nrDiasFeriaProv;
    protected $_nrCalendario;
    protected $_nrCalendarioAnterior;
    protected $_calendario;
    protected $_ocorrencia;
    protected $_idDifFerias;
    protected $_idDifSal;
    protected $baseMemoria;
    protected $calculoEventoMemoria;
    protected $tipoEventoRelacionado;
    protected $estrutura;
    protected $_dtInicioComp;
    protected $_dtFimComp;
    protected $itemFeriasOcorr2;
    protected $salarioProporcional;
    protected $dataSet;
    protected $geraNoMensal;
    protected $nrGozoFerias;
    protected $_idPagaAdicional;
    protected $_idConsalReducao;
    protected $_idConsolidaInss;
    protected $_idConsvincresc;
    protected $tpProcessamento;

    public function __construct($entityManager, $hcmParameters, $dataSet, $nr_tipo_calculo, $simulacao, $parcial, $dtmescompetenc = null){
        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->dataSet = $dataSet;
        $this->tpProcessamento = $dataSet['TP_PROCESSAMENTO'];
        $this->_nrorg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_idDebug = $hcmParameters->getIdDebug();
        $this->_ambiente_salario_operador = $hcmParameters->ambienteSalarioOperador();
        $this->_tp_modalidade_salario_operador = $hcmParameters->getTipoModalidadeSalario();
        $this->_nr_tipo_calculo = $nr_tipo_calculo;
        $this->_nrTipoModalidadeCalculo = $hcmParameters->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalculo = $hcmParameters->getNrOcorrenciaCalculo();
        $this->_simulacao = $simulacao;
        $this->_parcial = $parcial;
        $this->tipoEventoRelacionado = array();
        
        if($dtmescompetenc !== null) {
            $this->_mes_competencia = DateUtil::getDataDeString($dtmescompetenc);
            $this->_mes_competencia_int = $this->_mes_competencia->format('m');
        } else {
            $this->_mes_competencia = DateUtil::getDataDeString($hcmParameters->getDtCompetencia());
            $this->_mes_competencia_int = $this->_mes_competencia->format('m');
        }
        
        $this->_dt_pagamento = $dataSet['DTPAGAMENTO'];
        $this->_ultPagamento = $dataSet['IDULTPGTOMES'];
        $this->hcmParameters->setDtPagamento($this->_dt_pagamento);
        
        if(array_key_exists('IDMEMORIACALC', $dataSet)){
            $idMemoriaCalculo = $dataSet['IDMEMORIACALC'];
        }else{
            $idMemoriaCalculo = $dataSet['IDRETROCESSO'];
        }
        if(array_key_exists('OCORRENCIA_CALC', $dataSet)){
            $this->_vr_salarioDissidio = $dataSet['VRSALDISSIDIO'];
            $this->_id_fazDifComp = $dataSet['IDFAZDIFCOMP'];
            $this->_dtInicioComp = $dataSet['DTINI'];
            $this->_dtFimComp = $dataSet['DTFIM'];
            $this->_nrOcorrenciaCalculo = $dataSet['OCORRENCIA_CALC'];    
        }
        
        MemoriaCalculo::getInstance()->setExecutaMemoriaCalculo($idMemoriaCalculo);

        $this->_vr_salarioDissidio = null;
        $this->_id_fazDifComp = FpaFormresccomplementar::ID_FAZDIFERENCACOMP_SIM;

        $this->_ult_dia_mes = DateUtil::getUltimoDiaDoMes($this->_mes_competencia);
        
        $this->_primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno($this->_mes_competencia);

        $this->_inicio_periodo = $this->_mes_competencia;
        $this->_fim_periodo = $this->_ult_dia_mes;
        
        $this->_itens_salario_maternidade = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_origem = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_aviso_previo = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_ferias_vencidas_rescisao = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_13sal_resc = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_ferias_proporcionais_rescisao = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);
        $this->_itens_provisao_mes_anterior = new FpaitecalcfolhaEntity($entityManager, $hcmParameters, null, $this->_mes_competencia);

        $this->_tpFeriasVinc = new FpaTpferiasvincEntity($entityManager, $hcmParameters);

        $this->_valores_referencia = new FpaValorreferenciamEntity($entityManager, $hcmParameters);
        $this->_sit_evento = new GpesiteventoEntity($entityManager, $hcmParameters);
        
        $this->_nrTpVinculoAnterior = -1;
        $this->_alteracaoSalario = new GpealtesalarioEntity($entityManager, $hcmParameters);
        $this->_alteracaoOcupacao = new GpeAlteocupacaoEntity($entityManager, $hcmParameters);
        $this->_movimentosVinculo = new GpemovimentacaoEntity($entityManager, $hcmParameters);
        $this->vinculomEntity = new GpevinculomEntity($entityManager, $hcmParameters);
        
        $this->_idConsolidaInss = 'N';
        $this->_idPropSal = 'N';
        $this->_idConsalReducao = "S";
        $this->_idConsvincresc = "N";
        
        if($dataSet['IDCONSVINCRESC']){
            $this->_idConsvincresc = $dataSet['IDCONSVINCRESC'];
        }
        
        switch ($this->_nr_tipo_calculo) {
            case FpatipocalculoEntity::CALC_FERIAS:
                $this->_dtInicioGozo = $dataSet['DTINIGOZOFERIAS'];
                $this->_dtFimGozo = $dataSet['DTFIMGOZOFERIAS'];
                if(!$this->_dtInicioGozo){
                    $this->_dtInicioGozo = DateUtil::getDataDeString(substr($dataSet['DTINIGOZOINI'],0, 10));
                }
                if(!$this->_dtFimGozo){
                    $this->_dtFimGozo = DateUtil::getDataDeString(substr($dataSet['DTINIGOZOFIM'],0, 10));
                }
                break;
            case FpatipocalculoEntity::CALC_FOLHA:
            case FpatipocalculoEntity::CALC_RESCISAO:
                $this->_idPropSal = $dataSet['IDPROPSAL'];
                $this->_idDifFerias = $dataSet['IDDIFFERIAS'];
                $this->_idDifSal = $dataSet['IDDIFSAL'];
                $this->_idPagaAdicional = $dataSet['IDPAGAADIC'];
                $this->_idConsolidaInss = $dataSet['IDCONSOLIDAINSS'];
                $this->_idConsvincresc = $dataSet['IDCONSVINCRESC'];
                break;
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
                $this->_vr_salarioDissidio = $dataSet['VRSALDISSIDIO'];
                $this->_id_fazDifComp = $dataSet['IDFAZDIFCOMP'];
                $this->_idDifFerias = $dataSet['IDDIFFERIAS'];
                $this->_idDifSal = $dataSet['IDDIFSAL'];
                break;
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                $this->_idPropSal = $dataSet['IDPROPSAL'];
                break;
            case FpatipocalculoEntity::CALC_13SAL:
            case FpatipocalculoEntity::CALC_ADIANT_13SAL:
                $this->_idConsalReducao = $dataSet['IDCONSALREDUCAO'];
                $this->_idConsvincresc = $dataSet['IDCONSVINCRESC'];
                break;
        }

        $this->_media = new MediaEventosIntervalo($entityManager, $hcmParameters, $this->_dt_pagamento);

        $this->_eventomMedia = new FpaeventomEntity(
            $entityManager, $hcmParameters, $this->_dt_pagamento
        );
        
        $this->_calculo_folha = TkDI::getContainer()->calculo_folha;
        $this->_faltas_intervalo = new EventosFaltasIntervalo($entityManager, $hcmParameters);
        $this->_vinculo = TkDI::getContainer()->vinculom;
        $this->_assoc_eventos = TkDI::getContainer()->assoc_eventos;
        $this->_eventom = TkDI::getContainer()->eventom;
        $this->_escalam = TkDI::getContainer()->escalam;
        $this->_situacao_funcional = TkDI::getContainer()->situacao_funcional;
        $this->_alteracao_situacao_funcional = TkDI::getContainer()->alteracao_situacao_funcional;
        $this->_ferias = TkDI::getContainer()->ferias;
        $this->_gozo_ferias = TkDI::getContainer()->gozo_ferias;
        $this->_tipo_calculo = TkDI::getContainer()->tipo_calculo;
        $this->_obj_tipo_calculo = $this->_tipo_calculo->retornaTipoCalculo($this->_nr_tipo_calculo);
        $this->_paramCalculo = TkDI::getContainer()->param_calculo;
        
        $this->_itemGrupo = new FpaGrpitemEntity($entityManager, $hcmParameters);

        $this->_vincEvento = new FpaVinceventoEntity($entityManager, $hcmParameters);
        $this->_ocupacaoEvento = new FpaOcupaeventoEntity($entityManager, $hcmParameters);
        $this->_estruturaEvento = new FpaEstruteventoEntity($entityManager, $hcmParameters);

        $this->_estrutura = new EstruturamEntity($entityManager, $hcmParameters);

        $this->_nrCalendarioAnterior = -1;
        $this->_calendario = new CalendarioLogic($entityManager, $hcmParameters);

        $this->_fechamento = new Fechamento($entityManager, $hcmParameters, $this->_nr_tipo_calculo);
    }

    public function getVinculo(){
        return $this->_vinculo;
    }

    public function getAlteracaoSalario(){
        return $this->_alteracaoSalario;
    }

    public function getEventom(){
        return $this->_eventom;
    }

    public function getItensCalculoPrincipal(){
        return $this->_itens_calculo_principal;
    }

    public function getTpCalcMov(){
        return $this->_tpCalcMov;
    }

    public function getRegram(){
        return $this->_regram;
    }

    public function getTpCalcRegra(){
        return $this->_tpCalcRegra;
    }

    public function getNrorg(){
        return $this->_nrorg;
    }
    
    public function getOcorrencia(){
        return $this->_nrOcorrenciaCalculo;
    }

    public function getMesCompetencia(){
        return $this->_mes_competencia;
    }

    public function getJornadaDiaria(){
        return $this->_jornada_diaria;
    }

    public function getJornadaSemanal(){
        return $this->_jornada_semanal;
    }

    public function getDiasRemuneracao(){
        return $this->_dias_remuneracao;
    }

    public function getDiasTrabalhados(){
        return (int)$this->_dias_trabalhados;
    }

    public function getDiasNormais(){
        return $this->_dias_normais;
    }

    public function getDiasDSR(){
        return $this->_dias_rsr;
    }		

    public function getDiasFerias(){
        return $this->_dias_ferias;
    }

    public function getDiasAfastados(){
        return $this->_dias_afastados;
    }

    public function getDiasAtestados(){
        return $this->_dias_atestados;
    }

    public function getNrTipoCalculo(){
        return $this->_nr_tipo_calculo;
    }

    public function getSalario(){
        return $this->_salario;
    }
    
    public function getSalarioHora(){
        return $this->_salariohora;
    }

    public function getTipo_calculo(){
        return $this->_obj_tipo_calculo;
    }

    public function setListaProcessos($listaProcessos){
        $this->_listaProcessos = $listaProcessos;
    }

    public function setListaDireitos($listaDireitos){
        $this->_listaDireitos = $listaDireitos;
    }

    public function getDiasMaternidade(){
        return $this->_dias_maternidade;
    }

    public function getDiasUteisFer(){
        return $this->_dias_uteis_ferias;
    }

    public function getDiasRsrFer(){
        return $this->_dias_rsr_ferias;
    }

    public function getDiasUteis(){
        return $this->_dias_uteis;
    }
    
    public function getDiasDeSemana($data){
        $diasSemana = $this->_calendario->carregaDiasDeSemana($this->_nrCalendario, $data);
        return $diasSemana;
    }
    
    // calcula PLR a partir da quantidade de meses que é desejado voltar de acordo com o parâmetro passado na regra
    public function calculaAvosDireito($voltarMeses) {
        $vinculo = $this->getVinculo();
        
        $mesInicial = DateUtil::subtraiIntervalo($this->_mes_competencia, $voltarMeses, "M");
        $dtAdmissao = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
        $dtRescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        
        if ($dtAdmissao > $mesInicial) {
            if ($dtAdmissao->format('d') < 15) {
                $mesInicialVinc = DateUtil::getPrimeiroDiaDoMes($dtAdmissao);
            } else {
                $mesInicialVinc = DateUtil::adicionaIntervalo(DateUtil::getPrimeiroDiaDoMes($dtAdmissao), 1, "M");
            }
        } else {
            $mesInicialVinc = $mesInicial;
        }
        
        // verifica se o vínculo foi rescindido antes da data final para parar o cálculo antecipadamente
        if ($dtRescisao < $this->_mes_competencia && !empty($dtRescisao)) {
            if ($dtRescisao->format('d') > 15) {
                $mesFinalVinc = DateUtil::getPrimeiroDiaDoMes($dtRescisao);
            } else {
                $mesFinalVinc = DateUtil::subtraiIntervalo(DateUtil::getPrimeiroDiaDoMes($dtRescisao), 1, "M");
            }
        } else {
            $mesFinalVinc = $this->_mes_competencia;
        }
        
        for ($data_ini_aux = $mesInicialVinc; $data_ini_aux <= $mesFinalVinc; $data_ini_aux = DateUtil::adicionaIntervalo($data_ini_aux, 1, "M")) {
            $dias_intervalo = DateUtil::getQtdeDiasEntre($mesInicialVinc, $mesFinalVinc) + 1;
            
            if ($dias_intervalo >= 15) {
                $dias_afastados = $this->_quantidadeDiasAfastados($mesInicialVinc, $mesFinalVinc);
                $dias_faltas = $this->_quantidadeFaltas($vinculo, $mesInicialVinc, $mesFinalVinc);
                
                if (($dias_intervalo - $dias_afastados - $dias_faltas) >= 15) {
                    $nr_doze_avos++;
                }
            }
        }
        
        return $nr_doze_avos;
    }
    
    private function _quantidadeFaltas($vinculo, $dt_inicio, $dt_fim){
        
        $lista_eventos = $this->_faltas_intervalo->calcula($vinculo, $dt_inicio, $dt_fim, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalculo, $this->_nrOrgPadrao);
        
        $total_dias = 0;
        
        foreach ($lista_eventos as $nr_evento => $item_evento) {
            $evento = $this->_eventom->retornaEvento($nr_evento);
            $tipo_referencia = $evento->historico->getIdunidrefereven();
            $id_faltas_ferias = $evento->historico->getIdfaltasferias();
            
            $total_aux = number_format(FpaeventomEntity::compatibilizaReferenciaDias($item_evento['REF'], $tipo_referencia, $this->_jornada_diaria), 2);
            
            switch ($id_faltas_ferias){
                case FpaeventohEntity::IDFALTASFERIAS_SOMA:		
                    $total_dias += $total_aux; 
                    break;
                case FpaeventohEntity::IDFALTASFERIAS_SUBTRAI: 	
                    $total_dias -= $total_aux; 
                    break;
            }
        }
        
        return  floor($total_dias);

    }
    
    private function _quantidadeDiasAfastados($dt_inicio, $dt_fim){
        
        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento($this->_situacao_funcional, $dt_inicio, $dt_fim, false);
        
        $dias_afastados = 0;
        
        for ($i = 0; $i < count($afastamento); $i++) {
            $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional($this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]);
            
            if ($sit_func == true) {
                if ($sit_func->historico->getIdsusp13sal() === GpesitufunchEntity::IDSUSP13SAL_SIM) {
                    $dias_afastados++;
                }
            }
        }
        
        return $dias_afastados;
    }
}