<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;

class GpeOcupacaomEntity extends TkEntity
{

    private $_nrOrg;
    private $_mesCompetencia;
    private $_historicos;
    
   public function __construct($entityManager, $hcmParameters){

        parent::__construct(null, $entityManager);
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();
    }

    public function retornaOcupacao($nrOcupacao){
        $ocupacao = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOM)->retornaOcupacao($this->_nrOrg, $nrOcupacao, $this->_mesCompetencia);
        return $ocupacao;
    }

    public function retornaOcupacaoPorCodigoIntegracao($cdIntegracao){
        $ocupacao = GpeOcupacaom::retornaOcupacaoPorCodigoIntegracao(
            $this->_nrOrg, $cdIntegracao, $this->_mesCompetencia
        );
        return $ocupacao;
    }

    public function incluiOcupacao($nrtipoocupacao){
        try{
            $this->setNrtipoocupacao($nrtipoocupacao);
            $this->setDtinivigencia($this->_mesCompetencia);
            $this->setNrorg($this->_nrOrg);

            $this->persist();

            return true;
        }
        catch (Exception $e){
            return false;
        }
    }
    
    public function insereOcupacao($nrorg, $nrtipoocupacao, $dtinivigencia) {
        $this->setNrorg($nrorg);
        $this->setNrtipoocupacao($nrtipoocupacao);
        $this->setDtinivigencia($dtinivigencia);
    }

    public function getHistoricos() {
        if (!$this->_historicos) {
            $this->_historicos = self::getEntitiesByWhere('NRORG = ? AND NROCUPACAOM = ?');
        }
        return $this->_historicos;
    }

}