<?php

namespace HCM\Geral\Entity;

use HCM\Util\TkEntity;
use HCM\Util\Repositories;

class TpcalendarioEntity
{
    const IDTIPODIA_FERIADO = 'FERIADO';
    
    public function __construct($entityManager, $hcmParameters){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function retornaTipoCalendario($nrOrg, $nrOrgPadrao, $idTipoDia) {
        try {
            $resultados = $this->retornaTipoCalendarios($nrOrg, $nrOrgPadrao, $idTipoDia);
            return $resultados;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    //Função criada na entity pois tabela não possui entidade criada.
    public function retornaTipoCalendarios($nrOrg, $nrOrgPadrao, $idTipoDia){
    $sql = $this->entityManager->getConnection()->prepare("
            SELECT * 
             FROM TPCALENDARIO 
            WHERE
             (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO) 
             AND IDTIPODIA = :P_IDTIPODIA"
        );
        $sql->execute(
            array(
                "P_NRORG"=>$nrOrg,
                "P_NRORG_PADRAO"=>$nrOrgPadrao,
                "P_IDTIPODIA"=>$idTipoDia
                )
            );
        return $sql->fetchAll();
    }
}