<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class AprovacaoAdmissaoRepository{

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function getVinculosNaoAprovados($parameters, $conditions){
        $query = 
"SELECT * 
   FROM (SELECT /*+ ordered*/ VM.*,
                VH.NRVINCULOH,
                VH.NRSITUFUNCM,
                VH.NRCARGO,
                VH.NRESCALATRABM,
                VH.DTMESCOMPETENC,
                VH.IDCONTRIBUISIND,
                VH.NRDEPENDIR,
                VH.NRDEPENDSFAM,
                VH.DTBASEFERIAS,
                VH.IDREMUNERACAO,
                VH.IDTPPAGAMENTO,
                VH.NRESTRUTLEGAL,
                VH.NRESTRUTGEREN,
                VH.NRTPMODALIDSAL,
                VH.IDMULTVINC,
                VH.NRFUNCAO,
                VH.CDCONTRIBINDIVIDUAL,
                VH.NRTPMOVTRANSFM,
                VH.DTFIMCONTRDETERMIN,
                VH.NRESTRUTSIND,
                VH.CONFIDENCIAL,
                VH.NRTURNO,
                VH.NRTPREGIMEPREV,
                NVL(VH.IDPAGPROPFER13, 'N') IDPAGPROPFER13,
                PH.NMPESSOA,
                PH.NRPESSOAH,
                PH.NRCPFPESSOA,
                PH.NRPISPASEPPES,
                PH.NRRGPESSOA,
                PH.CDEXRGPESSOA,
                PH.DTEXRGPESSOA,
                PH.DSLOCALEXRGPES,
                PH.NRTITUELEIPES,
                PH.NRZONAELEIPES,
                PH.NRSECAELEIPES,
                PH.IDISENTITUELEI,
                PH.DTNASCPESSOA,
                PH.NRCTPSPESSOA,
                PH.NRSERIECTPSPES,
                PH.DTCTPSPESSOA,
                PH.DTINSCPISPASEP,
                PH.IDPESNATURALIZA,
                PH.DTNATURALIZAPES,
                PH.CDPAIS AS CDPAISNATURALI,
                (SELECT PAIS.NMPAIS 
                   FROM PAIS
                  WHERE PAIS.CDPAIS = PH.CDPAIS) AS NMPAISNATURALI,
                PH.SGESTADO AS SGESTADONATURALI,
                PH.CDMUNICIPIO AS CDMUNICIPIONATURALI,
                (SELECT MUNICIPIO.NMMUNICIPIO
                   FROM MUNICIPIO
                  WHERE MUNICIPIO.CDMUNICIPIO = PH.CDMUNICIPIO AND MUNICIPIO.CDPAIS = PH.CDPAIS AND MUNICIPIO.SGESTADO = PH.SGESTADO) AS NMMUNICIPIONATURALI,
                PH.DSEXPDOCESTR,
                PH.DTCHEGADAPAIS,
                PH.NRDOCUESTRANG,
                PH.SGUFRGPESSOA,
                PH.SGUFCTPSPES,
                PH.NRCLASSESTRANG,
                FPA_TPADMISSAO.NMTPADMISSAO,
                ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN,
                ESTRUTSIND.NMESTRUTURAM AS NMESTRUTSIND,
                TVH.NMTIPOVINCULOH,
                VE.NMVINCULOEMPREG,
                VE.NMABREV,
                TMT.NMTPMOVTRANSFH,
                RP.DSTPREGIMEPREV,
                CARGO.NMOCUPACAOH AS NMCARGO,
                FUNCAO.NMOCUPACAOH AS NMFUNCAO,
                CBO.NRCBO,
                CBO.NMCBO,
                GPE_ALTEESCALA.DTINIESCALA,
                GPE_ALTEESCALA.DTFIMESCALA,
                GPE_ALTEESCALA.QTHRLIMITESEPHEXTRA,
                ESC.NMESCALATRABH,
                GPE_TURNO.DSTURNO,
                SH.NMSITUFUNCH,
                TMS.NMTPMODALIDSAL,
                GPE_ALTESALARIO.IDTPSALARIO,
                GPE_ALTESALARIO.VRSALARIO,
                GPE_ALTESALARIO.NROCORRENCIA,
                GPE_TIPOSALARIO.DSTIPOSALARIO,
                ESTRG.NMESTADO AS NMUFRGPESSOA,
                ESTCTPS.NMESTADO AS NMUFCTPSPES,
                CONTCORRPARC.NRCONTCORRPARC,
                CONTCORRPARC.CDBANCO,
                CONTCORRPARC.CDAGENCIA,
                CONTCORRPARC.CDCONTCORR,
                CONTCORRPARC.NRTPCONTCORR,
                BANCO.NMBANCO,
                AGENCIA.NMAGENCIA,
                TPCONTCORR.DSTPCONTCORR,
                TELEFONE.NRCOMUNICAPARC AS CDTELEFONE,
                TELEFONE.CDCOMUNICAPARC AS NRTELEFONE,
                TELEFONE.CDPREFIXCOMUPARC AS PREFIXTELEFONE,
                EMAIL.NRCOMUNICAPARC AS CDEMAIL,
                EMAIL.CDCOMUNICAPARC AS DSEMAIL,
                ENDE.NRENDERECOPARC,
                ENDE.CDLOGRADOURO,
                ENDE.DSENDERECO,
                ENDE.NRIMOVELENDERECO,
                ENDE.NMBAIRROENDERECO,
                ENDE.NRCEPENDERECO,
                ENDE.SGESTADO,
                ENDE.CDPAIS,
                ENDE.CDMUNICIPIO,
                ENDE.DSCOMPLEENDERECO,
                ENDE.DSREFERENCIAENDE,
                MUN.NMMUNICIPIO,
                PAIS.NMPAIS,
                (SELECT LOGRADOURO.DSLOGRADOURO
                   FROM LOGRADOURO
                  WHERE LOGRADOURO.CDLOGRADOURO = ENDE.CDLOGRADOURO) AS DSLOGRADOURO,
                CLEST.DSCLASSESTRANG
           FROM GPE_VINCULOH VH
           JOIN GPE_VINCULOM VM ON VH.NRVINCULOM = VM.NRVINCULOM
                               AND VH.NRORG = VM.NRORG
                               AND VH.DTMESCOMPETENC = TO_DATE('01/01/3000')
           JOIN GPE_PESSOA PE ON PE.NRPESSOA = VM.NRPESSOA
                             AND PE.NRORG =VM.NRORG
           JOIN GPE_PESSOAH PH ON PH.NRPESSOA = PE.NRPESSOA 
                              AND PH.NRORG =  PE.NRORG
                              AND PH.DTMESCOMPETENC = (SELECT MAX(PHH.DTMESCOMPETENC)
                                                         FROM GPE_PESSOAH PHH
                                                        WHERE PHH.NRORG = PH.NRORG
                                                              AND   PHH.NRPESSOA = PH.NRPESSOA
                                                              AND   PHH.DTMESCOMPETENC <=:P_DTMESCOMPETENC)
           JOIN GPE_TIPOVINCULOH TVH ON TVH.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
                                    AND (TVH.NRORG = VM.NRORG OR TVH.NRORG =:P_NRORG_PADRAO)
                                    AND TVH.DTMESCOMPETENC = (SELECT MAX(TVHH.DTMESCOMPETENC)
                                                                FROM GPE_TIPOVINCULOH TVHH
                                                               WHERE TVHH.NRORG = TVH.NRORG
                                                                     AND   TVHH.NRTIPOVINCULOM = TVH.NRTIPOVINCULOM
                                                                     AND   TVHH.DTMESCOMPETENC <=:P_DTMESCOMPETENC)
           LEFT JOIN GPE_TPMOVTRANSFH TMT ON TMT.NRTPMOVTRANSFM = VH.NRTPMOVTRANSFM
                                         AND (TMT.NRORG = VH.NRORG OR TMT.NRORG =:P_NRORG_PADRAO)
                                          AND TMT.DTMESCOMPETENC = (SELECT MAX(TMTH.DTMESCOMPETENC)
                                                                      FROM GPE_TPMOVTRANSFH TMTH
                                                                     WHERE TMTH.NRORG = TMT.NRORG
                                                                           AND   TMTH.NRTPMOVTRANSFM = TMT.NRTPMOVTRANSFM
                                                                           AND   TMTH.DTMESCOMPETENC <=:P_DTMESCOMPETENC)
           LEFT JOIN GPE_OCUPACAOH CARGO ON CARGO.NROCUPACAOM = VH.NRCARGO
                                        AND CARGO.NRORG = VH.NRORG
                                        AND CARGO.DTMESCOMPETENC = (SELECT MAX(CARGOH.DTMESCOMPETENC)
                                                                      FROM GPE_OCUPACAOH CARGOH
                                                                     WHERE CARGOH.NRORG = CARGO.NRORG
                                                                           AND   CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM
                                                                           AND   CARGOH.DTMESCOMPETENC <=:P_DTMESCOMPETENC)
           LEFT JOIN GPE_OCUPACAOH FUNCAO ON FUNCAO.NROCUPACAOM = VH.NRFUNCAO
                                         AND FUNCAO.NRORG = VH.NRORG
                                         AND FUNCAO.DTMESCOMPETENC = ( SELECT MAX(FUNCAOH.DTMESCOMPETENC)
                                                                         FROM GPE_OCUPACAOH FUNCAOH
                                                                        WHERE FUNCAOH.NRORG = FUNCAO.NRORG
                                                                              AND   FUNCAOH.NROCUPACAOM = FUNCAO.NROCUPACAOM
                                                                              AND   FUNCAOH.DTMESCOMPETENC <=:P_DTMESCOMPETENC)
           LEFT JOIN GPE_CBO CBO ON FUNCAO.NRCBO = CBO.NRCBO
           LEFT JOIN ESTRUTURAM ESTRUTLEGAL ON ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                      AND ESTRUTLEGAL.NRORG = VH.NRORG
           LEFT JOIN ESTRUTURAM ESTRUTGEREN ON ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN
                                      AND ESTRUTGEREN.NRORG = VH.NRORG
           LEFT JOIN ESTRUTURAM ESTRUTSIND ON ESTRUTSIND.NRESTRUTURAM = VH.NRESTRUTSIND
                                          AND ESTRUTSIND.NRORG = VH.NRORG
           LEFT JOIN ESTADO ESTRG ON ESTRG.SGESTADO = PH.SGUFRGPESSOA
                                 AND ESTRG.CDPAIS = '0055'
           LEFT JOIN ESTADO ESTCTPS ON ESTCTPS.SGESTADO = PH.SGUFCTPSPES
                                   AND ESTCTPS.CDPAIS = '0055'
           JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
           LEFT  JOIN FPA_TPMODALIDSAL TMS ON TMS.NRTPMODALIDSAL = VH.NRTPMODALIDSAL
                                     AND (VH.NRORG = TMS.NRORG OR TMS.NRORG =:P_NRORG_PADRAO)
           LEFT JOIN GPE_ALTESALARIO ON VM.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                AND VM.NRORG = GPE_ALTESALARIO.NRORG
           LEFT JOIN GPE_TIPOSALARIO ON GPE_TIPOSALARIO.CDTIPOSALARIO = GPE_ALTESALARIO.IDTPSALARIO
           LEFT JOIN GPE_TPREGIMEPREV RP ON RP.NRTPREGIMEPREV = VH.NRTPREGIMEPREV
                                        AND ( VH.NRORG = RP.NRORG OR RP.NRORG =:P_NRORG_PADRAO)
           LEFT JOIN GPE_ALTEESCALA ON GPE_ALTEESCALA.NRESCALATRABM = VH.NRESCALATRABM
                              AND GPE_ALTEESCALA.NRVINCULOM = VM.NRVINCULOM
                              AND GPE_ALTEESCALA.NRORG = VH.NRORG
           LEFT JOIN GPE_ESCALATRABH ESC ON ESC.NRESCALATRABM = GPE_ALTEESCALA.NRESCALATRABM
                                   AND ESC.NRORG = VH.NRORG
                                   AND ESC.DTMESCOMPETENC = (SELECT MAX(ESCH.DTMESCOMPETENC)
                                                               FROM GPE_ESCALATRABH ESCH
                                                              WHERE ESCH.NRORG = ESC.NRORG
                                                                    AND   ESCH.NRESCALATRABM = ESC.NRESCALATRABM
                                                                    AND ESCH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
           LEFT JOIN GPE_TURNO ON GPE_TURNO.NRTURNO = GPE_ALTEESCALA.NRTURNO
                         AND GPE_TURNO.NRORG = GPE_ALTEESCALA.NRORG
           JOIN GPE_SITUFUNCH SH ON (SH.NRORG = VH.NRORG OR SH.NRORG =:P_NRORG_PADRAO)
                                AND SH.NRSITUFUNCM = VH.NRSITUFUNCM
                                AND SH.DTEFETIVA = (SELECT MAX(SHH.DTEFETIVA)
                                                      FROM GPE_SITUFUNCH SHH
                                                     WHERE SHH.NRORG = SH.NRORG
                                                           AND   SHH.NRSITUFUNCM = SH.NRSITUFUNCM
                                                           AND   DTEFETIVA <=:P_DTMESCOMPETENC)
           LEFT JOIN CONTCORRPARC ON CONTCORRPARC.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                 AND CONTCORRPARC.NRORG = PE.NRORG
           LEFT JOIN BANCO ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
                          AND (BANCO.NRORG = CONTCORRPARC.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO)
           LEFT JOIN TPCONTCORR ON TPCONTCORR.NRTPCONTCORR = CONTCORRPARC.NRTPCONTCORR
                               AND (TPCONTCORR.NRORG = CONTCORRPARC.NRORG OR TPCONTCORR.NRORG = :P_NRORG_PADRAO)
           LEFT JOIN AGENCIA ON CONTCORRPARC.CDAGENCIA = AGENCIA.CDAGENCIA
                            and contcorrparc.cdbanco = agencia.cdbanco
                            AND (AGENCIA.NRORG = CONTCORRPARC.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO)
           LEFT JOIN COMUNICAPARC TELEFONE ON PE.NRPARCNEGOCIO = TELEFONE.NRPARCNEGOCIO
                                          AND PE.NRORG = TELEFONE.NRORG
                                          AND TELEFONE.NRCOMUNICAPARC = (SELECT MAX(CP.NRCOMUNICAPARC)
                                                                           FROM COMUNICAPARC CP
                                                                          WHERE CP.NRPARCNEGOCIO = TELEFONE.NRPARCNEGOCIO
                                                                                AND CP.NRORG = TELEFONE.NRORG
                                                                                AND CP.CDFORMACOMU = '01')
           LEFT JOIN COMUNICAPARC EMAIL ON PE.NRPARCNEGOCIO = EMAIL.NRPARCNEGOCIO
                                       AND PE.NRORG = EMAIL.NRORG
                                       AND EMAIL.NRCOMUNICAPARC = (SELECT MAX(CP.NRCOMUNICAPARC)
                                                                     FROM COMUNICAPARC CP
                                                                    WHERE CP.NRPARCNEGOCIO = EMAIL.NRPARCNEGOCIO
                                                                          AND CP.NRORG = EMAIL.NRORG
                                                                          AND CP.CDFORMACOMU = '05')      
           LEFT JOIN ENDERECOPARC ENDE ON PE.NRPARCNEGOCIO = ENDE.NRPARCNEGOCIO
                                      AND PE.NRORG = ENDE.NRORG
                                      AND ENDE.NRENDERECOPARC = (SELECT MAX(ENDER.NRENDERECOPARC)
                                                                   FROM ENDERECOPARC ENDER 
                                                                  WHERE ENDER.NRPARCNEGOCIO = ENDE.NRPARCNEGOCIO
                                                                        AND ENDER.NRORG = ENDE.NRORG
                                                                        AND ENDER.CDTIPOENDERECO = 'PRINCIPAL')
           LEFT JOIN PAIS ON PAIS.CDPAIS = ENDE.CDPAIS
           LEFT JOIN MUNICIPIO MUN ON MUN.CDMUNICIPIO = ENDE.CDMUNICIPIO
                                  and mun.cdpais = ende.cdpais
                                  AND ENDE.SGESTADO = MUN.SGESTADO
           LEFT JOIN FPA_TPADMISSAO ON FPA_TPADMISSAO.NRTPADMISSAO = VM.NRTPADMISSAO
                                   AND (FPA_TPADMISSAO.NRORG = VM.NRORG OR FPA_TPADMISSAO.NRORG = :P_NRORG_PADRAO)
           LEFT JOIN GPE_CLASSESTRANG CLEST ON CLEST.NRCLASSESTRANG = PH.NRCLASSESTRANG  
            
            WHERE   VM.NRORG =:P_NRORG
                    AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
                    AND (VM.DTRESCISAOVINC IS NULL OR    VM.DTRESCISAOVINC >=:P_DTMESCOMPETENC)                                                                                             
           
        )
  WHERE 1 = 1". $conditions;
        $params = array('P_NRORG'          => $parameters['P_NRORG'],
                        'P_DTMESCOMPETENC' => $parameters['P_DTMESCOMPETENC'],
                        'P_NRORG_PADRAO'   => $parameters['P_NRORG_PADRAO']);
        return $this->connection->fetchAll($query, $params);                              
        
    }
    
    public function getPessoasNaoAprovadas($parameters, $conditions) {
        $query = "
SELECT
    PEH.NRPESSOAH,
    PEH.NRPESSOA,
    PEH.NRORG,
    PEH.DTMESCOMPETENC,
    PEH.NMPESSOA,
    PEH.DSPRONOMETRAT,
    PEH.DSAPELIDOPESS,
    PEH.DSPRINOMEPESS,
    PEH.DSULTNOMEPESS,
    PEH.DSNOMEMEIOPESS,
    PEH.NRCPFPESSOA,
    PEH.NRREGCTPSPES,
    PEH.NRCTPSPESSOA,
    PEH.NRSERIECTPSPES,
    PEH.SGUFCTPSPES,
    PEH.DTNASCPESSOA,
    PEH.IDSEXOPESSOA,
    PEH.NRRGPESSOA,
    PEH.DTADMISSAOPRE,
    PEH.CDRECIBOADMPRE,
    PEH.IDCOTAPCD,
    PEH.DTINCLUSAO,
    PEH.DTULTATU,
    PEH.NRORGINCLUSAO,
    PEH.CDOPERINCLUSAO,
    PEH.NRORGULTATU,
    PEH.CDOPERULTATU
FROM GPE_PESSOAH PEH
WHERE PEH.NRORG = :P_NRORG
  AND PEH.DTMESCOMPETENC = TO_DATE('01/01/3000', 'DD/MM/YYYY')
  AND PEH.NRPESSOA NOT IN ( SELECT VM.NRPESSOA
                            FROM GPE_VINCULOM VM
                            WHERE VM.NRORG = :P_NRORG )
ORDER BY PEH.NMPESSOA
".$conditions;
        $params = array( 'P_NRORG' => $parameters['P_NRORG'] );
        return $this->connection->fetchAll($query, $params);
    }
      
}