<?php
namespace Avaliacao\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class AvlLocalfilial extends Base\AvlLocalfilial
{
    public static function deleta($nrorg, $local, $filial){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $localfilial = self::getObjectByWhere(
                'NRORG = ? AND NRLOCAL = ? AND CDFILIAL = ?',
                array($nrorg, $local, $filial)
            );
            if ($localfilial instanceof AvlLocalfilial) {
                $localfilial->delete();

                $connection->flush();
                $connection->commit();
            }
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function deletaFilial($nrorg, $filial){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $registros = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ?',
                array($nrorg, $filial)
            );
            foreach($registros as $localfilial) {
                $localfilial->delete();
            }

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function deletaLocal($nrorg, $local){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $registros = self::getObjectsByWhere(
                'NRORG = ? AND NRLOCAL = ?',
                array($nrorg, $local)
            );
            foreach($registros as $localfilial) {
                $localfilial->delete();
            }

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function insere($nrorg, $codigo, $local, $filial){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try{
            $avllocalfilial = new AvlLocalfilial();
            $avllocalfilial->setNrlocalfilial($codigo);
            $avllocalfilial->setNrlocal($local);
            $avllocalfilial->setCdfilial($filial);
            $avllocalfilial->setNrorg($nrorg);
            $avllocalfilial->setNrorginclusao($nrorg);
            $avllocalfilial->setNrorgultatu($nrorg);
            $avllocalfilial->setDtinclusao(DateUtil::getDataAtual());
            $avllocalfilial->setDtultatu(DateUtil::getDataAtual());
            $avllocalfilial->setCdoperinclusao(Ambiente::getCdOperador());
            $avllocalfilial->setCdoperultatu(Ambiente::getCdOperador());
            $avllocalfilial->setIdativo('S');
            $avllocalfilial->persist();

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}