/*
TECNISA - PRODUTO INTEGRAO

NOME: SES_IMPORTA_NOTAFISCAL

DESCRIO:
  PROCEDIMENTO RESPONSAVEL PELA IMPORTAO DE NOTAS FISCAIS,
  ESPECIFICA DO CLIENTE SESI.

CRIAO:
02/05/2011 - JEFFERSON DE MELO GOUVEA

RAISERROR('', 16,1);

C:\Win_511\Sql\End_Conv\SqlServer\Clientes\Ses\0004_SESSTPS_SES_IMPORTA_NOTAFISCAL.SQL

*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'SES_IMPORTA_NOTAFISCAL' AND
              TYPE = 'P' 			      AND
              U.UID = O.UID            AND
              U.NAME = USER)

DROP PROCEDURE SES_IMPORTA_NOTAFISCAL
GO

CREATE PROCEDURE SES_IMPORTA_NOTAFISCAL
AS
   /*VARIVEIS DO CURSOR C_NF*/
   DECLARE @V_NF_CDCHAVE			VARCHAR(20);
   DECLARE @V_NF_CDFILIAL			VARCHAR(04);
   DECLARE @V_NF_CDEMPRESA			VARCHAR(02);
   DECLARE @V_NF_NRINSJURNF		VARCHAR(20);
   DECLARE @V_NF_NRNOTAFISC		VARCHAR(20);
   DECLARE @V_NF_DTEMISSAO			DATE;
   DECLARE @V_NF_DTENTRSAID		DATE;
   DECLARE @V_NF_IDENTRSAIDOP		VARCHAR(01);
   DECLARE @V_NF_CDTIPOOPER		VARCHAR(02);
   DECLARE @V_NF_CDSERIE			VARCHAR(05);
   DECLARE @V_NF_CDMODDOCFISC		VARCHAR(02);
   DECLARE @V_NF_CDFILIEMIT		VARCHAR(04);
   DECLARE @V_NF_CDFILIRECE		VARCHAR(04);
   DECLARE @V_NF_DTIMPORTA			DATE;
   DECLARE @V_NF_DSOBSERVERROS	VARCHAR(400);
   /*Variaveis do cursor C_ITEM*/
   DECLARE @V_IP_CDCHAVE			VARCHAR(20);
   DECLARE @V_IP_CDFILIAL			VARCHAR(04);
   DECLARE @V_IP_CDPRODUTO			VARCHAR(20);
   DECLARE @V_IP_QTITEMPROD		FLOAT;
   DECLARE @V_IP_VRUNITITEM		FLOAT;
   DECLARE @V_IP_VRDESCITEM		FLOAT;
   DECLARE @V_IP_VRTOTAITEM		FLOAT;
   DECLARE @V_IP_CDFISOPEITEM		VARCHAR(11);
   DECLARE @V_IP_CDSITUTRIBPR		VARCHAR(03);
   DECLARE @V_IP_CDALMOXARIFE		VARCHAR(06);
   DECLARE @V_IP_CDLOCALESTOQ		VARCHAR(06);
   DECLARE @V_IP_NRLOTEESTQ		VARCHAR(20);
   DECLARE @V_IP_NRSUBLOTE			VARCHAR(04);
   DECLARE @V_IP_DSOBSERVERROS	VARCHAR(400);
   /*Variaveis do cursor C_ITENC*/
   DECLARE @V_EG_CDCHAVE			VARCHAR(20);
   DECLARE @V_EG_CDFILIAL			VARCHAR(04);
   DECLARE @V_EG_CDENCARGO			VARCHAR(02);
   DECLARE @V_EG_VRITEMENCA		FLOAT;
   DECLARE @V_EG_DSOBSERVERROS	VARCHAR(400);
   /*Variaveis referentes as notas*/
   DECLARE @V_PROXCODIGO			VARCHAR(20);
   DECLARE @V_IDSISTEMA				VARCHAR(03);
   DECLARE @V_IDCTRLESTQ	      VARCHAR(01);
   DECLARE @V_DTPROCESSA			DATE;
   DECLARE @V_CDINSCESTA			VARCHAR(16);
   DECLARE @V_CDINSCMUNI			VARCHAR(16);
   DECLARE @V_CDFORNECED			VARCHAR(21);
   DECLARE @V_CDCLIENTE				VARCHAR(21);
   DECLARE @V_IDTPIJURNF			VARCHAR(01);
   DECLARE @V_CDSERIEENTR			VARCHAR(05);
   DECLARE @V_CDSERIE				VARCHAR(05);
   DECLARE @V_EXISTE					VARCHAR(20);
   DECLARE @V_NRLANCTONF			VARCHAR(20);
   DECLARE @V_IDORIGDESTNF			VARCHAR(01);
   DECLARE @V_NRSEQVENREC			VARCHAR(02);
   /*Logs*/
   DECLARE @V_NFLOG					VARCHAR(1000);
   DECLARE @V_PRODLOG				VARCHAR(400);
   /*Variaveis referentes aos itens*/
   DECLARE @V_CDALMOXARIFE			VARCHAR(06);
   DECLARE @V_CDNVPRODUTO			VARCHAR(01);
   DECLARE @V_CDLOCALESTOQ			VARCHAR(06);
   DECLARE @V_EITEM					VARCHAR(01);
   DECLARE @V_CDPRODUTO				VARCHAR(10);
   DECLARE @V_VRFATOCONV			DOUBLE PRECISION;
   DECLARE @V_DSPRODEMIS			VARCHAR(50);
   DECLARE @V_CDFILIMOVI			VARCHAR(04);
   DECLARE @V_IDTPLANCDESC			VARCHAR(01);
   DECLARE @V_VRDESCITEM			DOUBLE PRECISION;
   DECLARE @V_VRDESPERITEM			DOUBLE PRECISION;
   DECLARE @V_VRPRODUTOS			DOUBLE PRECISION;
   DECLARE @V_VRNOTAFISC			DOUBLE PRECISION;
   DECLARE @V_NRSEQITPROD			VARCHAR(04);
   DECLARE @V_NRITEM					DOUBLE PRECISION;
   DECLARE @V_NRLANCESTQ			VARCHAR(20);
   /*Variaveis referentes ao encargo*/
   DECLARE @V_EENCARGO				VARCHAR(01);
   DECLARE @V_ENCLOG					VARCHAR(400);
   /*Auxiliares*/
   DECLARE @V_IRREG_EST				VARCHAR(400);
   DECLARE @V_COUNTNF				DOUBLE PRECISION;
   DECLARE @V_COUNTIRREG			DOUBLE PRECISION;
   DECLARE @V_CANPROD				VARCHAR(25);
   DECLARE @V_PRIPROD				VARCHAR(01);

BEGIN
	SET @V_PROXCODIGO = '';
   /*Parametro para verificar apenas produto de nvel completo*/
   SELECT @V_CDNVPRODUTO = MAX(CDNVPRODUTO)
     FROM PRODUTO;

   /*Busca as notas fiscais ainda no importada*/
   DECLARE C_NF CURSOR FOR SELECT SES_NF.CDCHAVE, SES_NF.CDFILIAL, SES_NF.CDEMPRESA, SES_NF.NRINSJURNF,
   										 SES_NF.NRNOTAFISC, SES_NF.DTEMISSAO, SES_NF.DTENTRSAID, SES_NF.IDENTRSAIDOP,
                                  SES_NF.CDTIPOOPER, SES_NF.CDSERIE, SES_NF.CDMODDOCFISC, SES_NF.CDFILIEMIT,
                                  SES_NF.CDFILIRECE, SES_NF.DTIMPORTA, SES_NF.DSOBSERVERROS
   								  FROM USR_NOTAFISCAL SES_NF
                            WHERE DTIMPORTA IS NULL
                              AND CDCHAVE NOT IN (SELECT SES_CDCHAVE
                                                       FROM NOTAFISCAL
                                                      WHERE SES_CDCHAVE IS NOT NULL);

   OPEN C_NF;
   FETCH NEXT FROM C_NF INTO @V_NF_CDCHAVE, @V_NF_CDFILIAL, @V_NF_CDEMPRESA, @V_NF_NRINSJURNF,
   								  @V_NF_NRNOTAFISC, @V_NF_DTEMISSAO, @V_NF_DTENTRSAID, @V_NF_IDENTRSAIDOP,
   								  @V_NF_CDTIPOOPER, @V_NF_CDSERIE, @V_NF_CDMODDOCFISC, @V_NF_CDFILIEMIT,
                             @V_NF_CDFILIRECE, @V_NF_DTIMPORTA, @V_NF_DSOBSERVERROS;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      /*Busca a Data de Processamento da Filial*/
      SELECT @V_DTPROCESSA = MAX(DTPROCESSA), @V_IDCTRLESTQ = ISNULL(MAX(IDCTRLESTQ), 'S')
        FROM PARAMFILIAL
       WHERE CDFILIAL = @V_NF_CDFILIAL;

      /* Rotina para verificar se a filial da nota fiscal controla estoque */
      SELECT @V_IDCTRLESTQ = ISNULL(MAX(IDATUESTTPOP), @V_IDCTRLESTQ)
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = @V_NF_IDENTRSAIDOP
         AND CDTIPOOPER   = @V_NF_CDTIPOOPER;

		/*Inicializao da variavel onde sera gravado os erros.*/
      SET @V_NFLOG = '';

      /*Inicio da importao*/
      SELECT @V_EXISTE = MAX(CDFILIAL)
        FROM FILIAL
       WHERE CDFILIAL = @V_NF_CDFILIAL;
      IF @V_EXISTE IS NULL BEGIN
         SET @V_NFLOG = @V_NFLOG+'Filial '+@V_NF_CDFILIAL+' no cadastrada.* ';
      END;

      IF NOT @V_NF_CDFILIRECE IS NULL BEGIN
         SELECT @V_EXISTE = MAX(CDFILIAL)
           FROM FILIAL
          WHERE CDFILIAL = @V_NF_CDFILIRECE;
         IF @V_EXISTE IS NULL BEGIN
   	      SET @V_NFLOG = @V_NFLOG+'Filial de recebimento '+@V_NF_CDFILIAL+' no cadastrada.* ';
         END;
      END;

      IF NOT @V_NF_CDFILIEMIT IS NULL BEGIN
         SELECT @V_EXISTE = MAX(CDFILIAL)
           FROM FILIAL
          WHERE CDFILIAL = @V_NF_CDFILIEMIT;
         IF @V_EXISTE IS NULL BEGIN
            SET @V_NFLOG = @V_NFLOG+'Filial de emissao '+@V_NF_CDFILIAL+' no cadastrada.* ';
         END;
      END;

      SELECT @V_EXISTE = MAX(CDEMPRESA)
        FROM EMPRESA
       WHERE CDEMPRESA = @V_NF_CDEMPRESA;
      IF @V_EXISTE IS NULL BEGIN
         SET @V_NFLOG = @V_NFLOG+'Empresa '+@V_NF_CDEMPRESA+' no cadastrada.* ';
      END;

      SELECT @V_EXISTE = MAX(I.NRINSJURNF)
        FROM (SELECT NRINSJURFILI AS NRINSJURNF
                FROM FILIAL
               WHERE NRINSJURFILI = @V_NF_NRINSJURNF
              UNION ALL
              SELECT NRINSJURFORN AS NRINSJURNF
                FROM FORNECEDOR
               WHERE NRINSJURFORN = @V_NF_NRINSJURNF
               UNION ALL
              SELECT NRINSJURCLIE AS NRINSJURNF
                FROM CLIENTE
               WHERE NRINSJURCLIE = @V_NF_NRINSJURNF) I;
      IF @V_EXISTE IS NULL BEGIN
         SET @V_NFLOG = @V_NFLOG+'Inscrio Jurdica '+@V_NF_NRINSJURNF+' no cadastrada.* ';
      END;

      SELECT @V_EXISTE = MAX(CDTIPOOPER)
        FROM TIPOOPERAC
       WHERE CDTIPOOPER   = @V_NF_CDTIPOOPER
         AND IDENTRSAIDOP = @V_NF_IDENTRSAIDOP;
      IF @V_EXISTE IS NULL BEGIN
         SET @V_NFLOG = @V_NFLOG+'Tipo de operao '+@V_NF_CDTIPOOPER+' no cadastrado.* ';
      END;

      IF @V_NF_IDENTRSAIDOP = 'E' BEGIN
         SELECT @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
           FROM EMPRCNTRFIL
          WHERE (CDFILIAL  = @V_NF_CDFILIRECE) AND
                (CDEMPRESA = @V_NF_CDEMPRESA);
         IF (@V_CDINSCESTA IS NULL) OR (@V_CDINSCMUNI IS NULL) BEGIN
            SELECT @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
              FROM FILIAL
             WHERE (CDFILIAL  = @V_NF_CDFILIRECE) AND
                   (CDEMPRESA = @V_NF_CDEMPRESA);
         END;

         SELECT @V_EXISTE = MAX(CDSERIEENTR)
           FROM SERIEENTR
          WHERE CDSERIEENTR = @V_NF_CDSERIE
            AND @V_NF_IDENTRSAIDOP = 'E';
         IF @V_EXISTE IS NULL BEGIN
            SET @V_NFLOG = @V_NFLOG+'Srie de Entrada '+@V_NF_CDSERIE+' no cadastrada.* ';
         END;
      END
      ELSE BEGIN
         SELECT @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
           FROM EMPRCNTRFIL
          WHERE (CDFILIAL  = @V_NF_CDFILIEMIT) AND
                (CDEMPRESA = @V_NF_CDEMPRESA);
         IF (@V_CDINSCESTA IS NULL) OR (@V_CDINSCMUNI IS NULL) BEGIN
            SELECT @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
              FROM FILIAL
             WHERE (CDFILIAL  = @V_NF_CDFILIEMIT) AND
                   (CDEMPRESA = @V_NF_CDEMPRESA);
         END;

         SELECT @V_EXISTE = MAX(S.CDSERIE)
           FROM SERIENF S
          WHERE S.CDSERIE    = @V_NF_CDSERIE
            AND S.CDEMPRESA  = @V_NF_CDEMPRESA
            AND S.CDINSCESTA = @V_CDINSCESTA
            AND S.CDINSCMUNI = @V_CDINSCMUNI
            AND @V_NF_IDENTRSAIDOP = 'S';
         IF @V_EXISTE IS NULL BEGIN
            SET @V_NFLOG = @V_NFLOG+'Srie de Sada '+@V_NF_CDSERIE+' no cadastrada.*  ';
         END;
         SET @V_CDSERIE   = @V_NF_CDSERIE;
         SET @V_IDSISTEMA = 'DFS';
      END;

      SELECT @V_EXISTE = MAX(CDMODDOCFISC)
        FROM MODDOCFISC
       WHERE CDMODDOCFISC = @V_NF_CDMODDOCFISC;
      IF @V_EXISTE IS NULL BEGIN
         SET @V_NFLOG = @V_NFLOG+'Modelo de Documento fiscal '+@V_NF_CDMODDOCFISC+' no cadastrado.* ';
      END;

      /*Grava o log de erros*/          
      IF @V_NFLOG <> '' BEGIN
         UPDATE USR_NOTAFISCAL
            SET DSOBSERVERROS = @V_NFLOG
          WHERE CDCHAVE = @V_NF_CDCHAVE;
      END
      ELSE BEGIN
         UPDATE USR_NOTAFISCAL
            SET DSOBSERVERROS = ''
          WHERE CDCHAVE = @V_NF_CDCHAVE;

         /*Rotina de importao de nota fiscal*/
         SET @V_CDFORNECED  = NULL;
         SET @V_CDCLIENTE   = NULL;
         SET @V_IDTPIJURNF  = NULL;
         SET @V_CDSERIEENTR = NULL;
         SET @V_CDSERIE     = NULL;

         /*Novo codigo NRLANCTONF*/
         SET @V_PROXCODIGO = 'LANCNF/FILIAL'+@V_NF_CDFILIAL;
         EXEC NOVO_CODIGO @V_PROXCODIGO, @V_NRLANCTONF OUTPUT, @P_QTDE = 1;
         SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);
         IF @V_IDCTRLESTQ = 'S' BEGIN
            SET @V_PROXCODIGO = 'LANCTOEST'+@V_NF_CDFILIAL;
            EXEC NOVO_CODIGO @V_PROXCODIGO, @V_NRLANCESTQ OUTPUT, @P_QTDE = 1;
            SET @V_NRLANCESTQ = SUBSTRING(@V_NRLANCESTQ, 11, 10);
         END;

         /*Verifica se a nota  de origem fornecedor, filial ou cliente*/
         SELECT @V_IDORIGDESTNF = (CASE @V_NF_IDENTRSAIDOP WHEN 'E' THEN ISNULL(MAX(IDORIGDESTOP),'F') ELSE ISNULL(MAX(IDORIGDESTOP),'C') END)
           FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = @V_NF_IDENTRSAIDOP
            AND CDTIPOOPER   = @V_NF_CDTIPOOPER;
         IF @V_IDORIGDESTNF = 'F' BEGIN
            SELECT @V_CDFORNECED = MAX(CDFORNECED), @V_IDTPIJURNF = MAX(IDTPIJURFORN)
              FROM FORNECEDOR
             WHERE NRINSJURFORN = @V_NF_NRINSJURNF;
         END
         ELSE BEGIN
            IF @V_IDORIGDESTNF = 'L' BEGIN
               SELECT @V_IDTPIJURNF = MAX(IDTPIJURFILI)
                 FROM FILIAL
                WHERE CDFILIAL = (CASE @V_NF_IDENTRSAIDOP WHEN 'E' THEN @V_NF_CDFILIEMIT ELSE @V_NF_CDFILIRECE END);
            END
            ELSE BEGIN
               SELECT @V_CDCLIENTE = MAX(CDCLIENTE), @V_IDTPIJURNF = MAX(IDTPIJURCLIE)
                 FROM CLIENTE
                WHERE NRINSJURCLIE = @V_NF_NRINSJURNF;
            END;
         END;

         /*Verifica qual o sistema que foi gerada a nota fiscal*/
         IF @V_NF_IDENTRSAIDOP = 'S' BEGIN
            SET @V_CDSERIE     = @V_NF_CDSERIE;
            SET @V_IDSISTEMA   = 'DFS';
         END
         ELSE BEGIN
            SET @V_CDSERIEENTR = @V_NF_CDSERIE;
            SET @V_IDSISTEMA   = 'DFE';
            SELECT @V_NF_NRNOTAFISC = RIGHT(REPLICATE(0, ISNULL(MAX(NRTAMNUMNFUTDFE),10)) + @V_NF_NRNOTAFISC,
            		 ISNULL(MAX(NRTAMNUMNFUTDFE),10))
              FROM PARAMFILIAL
             WHERE CDFILIAL = @V_NF_CDFILIAL;
         END;

         /*Insere na tabela NOTAFISCAL as informaes referentes a nota fiscal*/
         INSERT INTO NOTAFISCAL
           (CDFILIAL,     NRLANCTONF,     CDEMPRESA,     CDINSCESTA,
            CDINSCMUNI,   CDFILIEMIT,     CDFILIRECE,    NRINSJURNF,
            IDBLOQUEADO,  IDDOCFISCAL,    IDDOCFINANC,   DTENTRSAID,
            VRPRODUTOS,   VRNOTAFISC,     IDENTRSAIDOP,  CDTIPOOPER,
            CDSERIE,      IDDOCCONTAB,    IDSTATUS,      IDDOCFISCENT,
            CDMODDOCFISC, DTEMISSAO,
            CDFORNECED,   CDCLIENTE,      IDTPIJURNF,    NRNOTAFISC,
            CDSERIEENTR,  IDSISTEMA,      IDORIGDESTNF,  SES_CDCHAVE)
         VALUES
           (@V_NF_CDFILIAL,     @V_NRLANCTONF,      @V_NF_CDEMPRESA,    		@V_CDINSCESTA,
            @V_CDINSCMUNI,      @V_NF_CDFILIEMIT,   @V_NF_CDFILIRECE,   		@V_NF_NRINSJURNF,
            'N',               'S',                 'S',                		CONVERT(DATE, @V_NF_DTENTRSAID),
             0,                 0,                  @V_NF_IDENTRSAIDOP, 		@V_NF_CDTIPOOPER,
            @V_CDSERIE,         'S',                'P', 	'N',
            @V_NF_CDMODDOCFISC, CONVERT(DATE, @V_NF_DTEMISSAO),
            @V_CDFORNECED,      @V_CDCLIENTE,       @V_IDTPIJURNF,      		@V_NF_NRNOTAFISC,
            @V_CDSERIEENTR,     @V_IDSISTEMA,       @V_IDORIGDESTNF,    		@V_NF_CDCHAVE);

         SET @V_VRPRODUTOS  = 0;
         SET @V_VRNOTAFISC  = 0;
         SET @V_NRSEQITPROD = '0001';
         SET @V_EITEM       = '0';
         SET @V_EENCARGO    = '0';

         /*Inicio da rotina de importao de itens*/
   		DECLARE C_ITEM CURSOR FOR SELECT SES_IP.CDCHAVE, SES_IP.CDFILIAL, SES_IP.CDPRODUTO, SES_IP.QTITEMPROD,
         											SES_IP.VRUNITITEM, SES_IP.VRDESCITEM, SES_IP.VRTOTAITEM, SES_IP.CDFISOPEITEM,
   													SES_IP.CDSITUTRIBPR, SES_IP.CDALMOXARIFE, SES_IP.CDLOCALESTOQ,
                                          SES_IP.NRLOTEESTQ, SES_IP.NRSUBLOTE, SES_IP.DSOBSERVERROS
         									 FROM USR_ITEMPRODUTO SES_IP
      										WHERE SES_IP.CDCHAVE = @V_NF_CDCHAVE;

         OPEN C_ITEM;
         FETCH NEXT FROM C_ITEM INTO @V_IP_CDCHAVE, @V_IP_CDFILIAL, @V_IP_CDPRODUTO, @V_IP_QTITEMPROD,
      										 @V_IP_VRUNITITEM, @V_IP_VRDESCITEM, @V_IP_VRTOTAITEM, @V_IP_CDFISOPEITEM,
   											 @V_IP_CDSITUTRIBPR, @V_IP_CDALMOXARIFE, @V_IP_CDLOCALESTOQ,
               	                   @V_IP_NRLOTEESTQ, @V_IP_NRSUBLOTE, @V_IP_DSOBSERVERROS;

         SET @V_EITEM = 0;
      	WHILE (@@FETCH_STATUS = 0) BEGIN
            /*Rotina de verificao de inconsistncias*/
            SET @V_PRODLOG = '';
            IF @V_IP_CDALMOXARIFE IS NULL BEGIN
            	SET @V_CDALMOXARIFE = ' ';
            END
            ELSE BEGIN
   				SET @V_CDALMOXARIFE = @V_IP_CDALMOXARIFE;
            END;
            IF @V_IP_CDLOCALESTOQ IS NULL BEGIN
            	SET @V_CDLOCALESTOQ = ' ';
            END
            ELSE BEGIN
               SET @V_CDLOCALESTOQ = @V_IP_CDALMOXARIFE;
            END;

   			SELECT @V_EXISTE = MAX(CDFILIAL)
              FROM FILIAL
   			 WHERE CDFILIAL = @V_IP_CDFILIAL;
   			IF @V_EXISTE IS NULL BEGIN
   				SET @V_PRODLOG = @V_PRODLOG+'Filial '+@V_IP_CDFILIAL+' no cadastrada.* ';
   			END;

   			SELECT @V_EXISTE = MAX(CDPRODUTO)
              FROM PRODUTO
   			 WHERE CDARVPROD = @V_IP_CDPRODUTO
   				AND CDNVPRODUTO = @V_CDNVPRODUTO;
   			IF @V_EXISTE IS NULL BEGIN
   				SET @V_PRODLOG = @V_PRODLOG+'Produto '+@V_IP_CDPRODUTO+' no cadastrado.* ';
   			END;

   			SELECT @V_EXISTE = MAX(CDALMOXARIFE)
   			  FROM ALMOXARIFADO
   			 WHERE CDFILIAL     = @V_IP_CDFILIAL
   				AND CDALMOXARIFE = @V_CDALMOXARIFE;
   			IF @V_EXISTE IS NULL BEGIN
   				SET @V_PRODLOG = @V_PRODLOG+'Almoxarifado '+@V_CDALMOXARIFE+' no cadastrado.* ';
   			END;

   			SELECT @V_EXISTE = MAX(CDLOCALESTOQ)
              FROM LOCALESTOQUE
             WHERE CDFILIAL     = @V_IP_CDFILIAL
   				AND CDALMOXARIFE = @V_CDALMOXARIFE
   				AND CDLOCALESTOQ = @V_CDLOCALESTOQ;
   			IF @V_EXISTE IS NULL BEGIN
   				SET @V_PRODLOG = @V_PRODLOG+'Localizao '+@V_CDLOCALESTOQ+' no cadastrada.* ';
   			END;

   			/*Grava o log de erros para o item importado*/
            IF @V_PRODLOG <> '' BEGIN
   				SET @V_EITEM = '1';
   				UPDATE USR_ITEMPRODUTO
   					SET DSOBSERVERROS  = @V_PRODLOG
   				 WHERE CDCHAVE     = @V_IP_CDCHAVE
   					AND CDPRODUTO   = @V_IP_CDPRODUTO
   					AND VRUNITITEM  = @V_IP_VRUNITITEM;
            END
   			ELSE BEGIN
   				UPDATE USR_ITEMPRODUTO
   					SET DSOBSERVERROS  = ''
   				 WHERE CDCHAVE    = @V_IP_CDCHAVE
   					AND CDPRODUTO  = @V_IP_CDPRODUTO
                  AND VRUNITITEM = @V_IP_VRUNITITEM;

               /*Importao dos Itens da Nota*/
               IF (@V_NF_IDENTRSAIDOP = 'S') BEGIN
   					SET @V_CDFILIMOVI = @V_NF_CDFILIEMIT;
               END
   				ELSE BEGIN
   					SET @V_CDFILIMOVI = @V_NF_CDFILIRECE;
   				END;

   				SELECT @V_CDPRODUTO = MAX(CDPRODUTO), @V_VRFATOCONV = MAX(VRFATOCONV), @V_DSPRODEMIS = MAX(NMPRODUTO)
   				  FROM PRODUTO
   				 WHERE CDARVPROD = @V_IP_CDPRODUTO;
   				SELECT @V_IDTPLANCDESC = ISNULL(MAX(IDTPLANCDESC),'V')
   				  FROM PARAMGERAL;

               IF @V_IDTPLANCDESC = 'V' BEGIN
   					SET @V_VRDESCITEM = @V_IP_VRDESCITEM;
   					IF  @V_IP_VRTOTAITEM > 0  BEGIN
   						SET @V_VRDESPERITEM = ROUND((@V_IP_VRDESCITEM * 100)/@V_IP_VRTOTAITEM, 4);
                  END
   					ELSE BEGIN
   						SET @V_VRDESPERITEM = 0;
   					END;
               END
   				ELSE BEGIN
   				   IF @V_IP_VRDESCITEM > 0  BEGIN
   					   SET @V_VRDESPERITEM = @V_IP_VRDESCITEM;
   		 			   SET @V_VRDESCITEM = ROUND(((@V_IP_VRUNITITEM * @V_IP_VRDESCITEM) / 100) * @V_IP_QTITEMPROD, 4);
                  END
   				   ELSE BEGIN
   					   SET @V_VRDESPERITEM = 0;
   					   SET @V_VRDESCITEM   = 0;
   				   END;
               END;

 	            /*Insere os produtos na Tabela ITEMPRODUTO*/
	            INSERT INTO ITEMPRODUTO
	            	(CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,
	   				 CDPRODEMIS,   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,
	   				 VRUNITITEM,   VRDESCITEM,   VRTOTAITEM,   VRCONTITEM,
	   				 IDCONFORITEM, VRBRUTITEM,   VRDESPERITEM, CDFILIMOVI,
	                CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
	                CDMARCA)
	   			VALUES
	   				(@V_IP_CDFILIAL,   @V_NRLANCTONF,      @V_NRSEQITPROD,  @V_CDPRODUTO,
	   				 @V_IP_CDPRODUTO,  @V_DSPRODEMIS,      'S',             @V_IP_QTITEMPROD,
	                @V_IP_VRUNITITEM, @V_VRDESCITEM, ROUND(@V_IP_VRTOTAITEM,2), ROUND(@V_IP_VRTOTAITEM,2),
	                'S',               ROUND(@V_IP_VRTOTAITEM,2), @V_VRDESPERITEM, @V_CDFILIMOVI,
	                @V_CDALMOXARIFE,    @V_CDLOCALESTOQ,  ISNULL(@V_IP_NRLOTEESTQ,' '), ISNULL(@V_IP_NRSUBLOTE,' '),
	   				 '99999');

	            SET @V_VRPRODUTOS  = @V_VRPRODUTOS + @V_IP_VRTOTAITEM;
	            SET @V_VRNOTAFISC  = @V_VRNOTAFISC + @V_IP_VRTOTAITEM - @V_VRDESCITEM;
	            SET @V_NRSEQITPROD = RIGHT(REPLICATE('0',4)+CONVERT(VARCHAR,(CONVERT(INTEGER,@V_NRSEQITPROD) + 1)),4);
            END;

            FETCH NEXT FROM C_ITEM INTO @V_IP_CDCHAVE, @V_IP_CDFILIAL, @V_IP_CDPRODUTO, @V_IP_QTITEMPROD,
   	   										 @V_IP_VRUNITITEM, @V_IP_VRDESCITEM, @V_IP_VRTOTAITEM, @V_IP_CDFISOPEITEM,
   												 @V_IP_CDSITUTRIBPR, @V_IP_CDALMOXARIFE, @V_IP_CDLOCALESTOQ,
         	      	                   @V_IP_NRLOTEESTQ, @V_IP_NRSUBLOTE, @V_IP_DSOBSERVERROS;

   		END;

         CLOSE C_ITEM;
      	DEALLOCATE C_ITEM;
   		/*Verifica se ouve algum erro durante a importao dos produtos da nota fiscal*/
   		IF @V_EITEM = '0' BEGIN
   			SELECT @V_NRITEM = COUNT(*)
   			  FROM ITEMPRODUTO
     	       WHERE CDFILIAL   = @V_NF_CDFILIAL
   				AND NRLANCTONF = @V_NRLANCTONF;
   			IF (@V_NRITEM = 0 OR @V_NRITEM = NULL) BEGIN
   				SET @V_EITEM = '1';
   				UPDATE USR_NOTAFISCAL
   					SET DSOBSERVERROS = @V_NFLOG +' Nota fiscal com itens irregulares.* '
   			 	 WHERE CDCHAVE = @V_NF_CDCHAVE;
   			END;
   		END;
         /*Deleta a nota e os idens importados*/
         IF @V_EITEM = '1' BEGIN
            DELETE FROM AUDITORIA
             WHERE CDFILIALNF = @V_NF_CDFILIAL
            	AND NRLANCTONF = @V_NRLANCTONF;
            DELETE FROM ITEMPRODUTO
             WHERE NRLANCTONF = @V_NRLANCTONF
            	AND CDFILIAL   = @V_NF_CDFILIAL;
            DELETE FROM ITEMNOTAFISC
             WHERE NRLANCTONF = @V_NRLANCTONF
            	AND CDFILIAL   = @V_NF_CDFILIAL;
            DELETE FROM NOTAFISCAL
             WHERE NRLANCTONF = @V_NRLANCTONF
            	AND CDFILIAL   = @V_NF_CDFILIAL;
         END;

         /*Rotina de importao dos Encargos da nota fiscal*/
         DECLARE C_ITENC CURSOR FOR SELECT EG.CDCHAVE, EG.CDFILIAL, EG.CDENCARGO, EG.VRITEMENCA,
         											 EG.DSOBSERVERROS
         									  FROM USR_ITEMENCARGO EG
      										 WHERE EG.CDCHAVE = @V_NF_CDCHAVE;

         OPEN C_ITENC;
         FETCH NEXT FROM C_ITENC INTO @V_EG_CDCHAVE, @V_EG_CDFILIAL, @V_EG_CDENCARGO, @V_EG_VRITEMENCA,
         									  @V_EG_DSOBSERVERROS;

      	WHILE (@@FETCH_STATUS = 0) BEGIN
            /*Rotina de verificao de inconsistncias*/
            SET @V_ENCLOG = '';
   			SELECT @V_EXISTE = MAX(CDFILIAL)
              FROM FILIAL
   			 WHERE CDFILIAL = @V_EG_CDFILIAL;
   			IF @V_EXISTE IS NULL BEGIN
   				SET @V_ENCLOG = @V_ENCLOG+'Filial '+@V_EG_CDFILIAL+' no cadastrada.* ';
   			END;
   			SELECT @V_EXISTE = MAX(CDENCARGO)
              FROM ENCARGO
   			 WHERE CDENCARGO = @V_EG_CDENCARGO;
            IF @V_EXISTE IS NULL BEGIN
   				SET @V_ENCLOG = @V_ENCLOG+'Encargo '+@V_EG_CDENCARGO+' no cadastrado.* ';
   			END;

            /*Grava o log de erro para os encargos*/
            IF @V_ENCLOG <> '' BEGIN
   				SET @V_EENCARGO = '1';
   				UPDATE USR_NOTAFISCAL
   					SET DSOBSERVERROS = 'Operao Bloqueada! Erro de encargo.* '
   				 WHERE CDCHAVE = @V_NF_CDCHAVE;
   				UPDATE USR_ITEMENCARGO
   					SET DSOBSERVERROS  = @V_ENCLOG
   				 WHERE CDCHAVE   = @V_EG_CDCHAVE
   					AND CDENCARGO = @V_EG_CDENCARGO;
            END
   			ELSE BEGIN
   				UPDATE USR_ITEMENCARGO
   					SET DSOBSERVERROS  = ''
                WHERE CDCHAVE    = @V_EG_CDCHAVE
   					AND CDENCARGO  = @V_EG_CDENCARGO;

   				/*Importao dos Encargos da Nota Fiscal*/
   				INSERT INTO ITEMENCARGO
   							(CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
   						VALUES
   							(@V_EG_CDFILIAL, @V_NRLANCTONF, @V_EG_CDENCARGO, @V_EG_VRITEMENCA);
            END;
            FETCH NEXT FROM C_ITENC INTO @V_EG_CDCHAVE, @V_EG_CDFILIAL, @V_EG_CDENCARGO, @V_EG_VRITEMENCA,
            									  @V_EG_DSOBSERVERROS;
   		END;

         CLOSE C_ITENC;
      	DEALLOCATE C_ITENC;

         /*Se houver erro em algum encargo, deleta a nota, os itens e os encargos importados*/
   		IF @V_EENCARGO = '1' BEGIN
   			DELETE FROM ITEMENCARGO
             WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   			DELETE FROM AUDITORIA
   			 WHERE CDFILIALNF = @V_NF_CDFILIAL
   				AND NRLANCTONF = @V_NRLANCTONF;
   			DELETE FROM ITEMNOTAFISC
   			 WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   			DELETE FROM ITEMPRODUTO
   			 WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   			DELETE FROM NFRELACAF
   			 WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   			DELETE FROM CONTARECEBER
   			 WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   			DELETE FROM NOTAFISCAL
   			 WHERE NRLANCTONF = @V_NRLANCTONF
   				AND CDFILIAL   = @V_NF_CDFILIAL;
   		END;

         /*Rotina para gerar os impostos, contas a pagar e atualizar o estoque para notas de entrada e saida*/
         IF ((@V_NFLOG = '') AND (@V_EITEM = '0') AND (@V_EENCARGO = '0')) BEGIN
            IF @V_NF_IDENTRSAIDOP = 'E' BEGIN
               SET @V_IRREG_EST = '0';
               EXEC SES_TRAB_IMPOSTO_ENTRADA @V_NF_CDFILIAL, @V_NRLANCTONF, @V_NRLANCESTQ, @V_VRNOTAFISC OUTPUT;
               IF @V_VRNOTAFISC = 0 BEGIN
   					SET @V_COUNTNF = 0;
   					SELECT @V_COUNTNF = ISNULL(COUNT(*), 0)
                    FROM ITEMPROIMPOS I, IMPOSTO M
                   WHERE I.CDIMPOSTO  = M.CDIMPOSTO
   						AND I.CDFILIAL   = @V_NF_CDFILIAL
   						AND I.NRLANCTONF = @V_NRLANCTONF
                     AND M.IDTRATIMPO IN ('A','D');
   					IF @V_COUNTNF = 0 BEGIN
   						SET @V_VRNOTAFISC = @V_VRPRODUTOS;
   					END ELSE BEGIN
   						SET @V_IRREG_EST = '1';
   						EXEC DELETA_NF @V_NF_CDFILIAL, @V_NRLANCTONF;
   						UPDATE USR_NOTAFISCAL
   							SET DSOBSERVERROS = 'Importao bloqueada. Nota Fiscal com valor zerado.'
   						 WHERE CDCHAVE = @V_NF_CDCHAVE;
   					END;
                  EXEC CONFERE_ERROS_NF @V_NF_CDFILIAL, @V_NRLANCTONF, @V_VRNOTAFISC;
   				END;
   				IF @V_IRREG_EST = '0' BEGIN
   					UPDATE NOTAFISCAL
   						SET VRNOTAFISC = @V_VRNOTAFISC
   					 WHERE CDFILIAL   = @V_NF_CDFILIAL
   						AND NRLANCTONF = @V_NRLANCTONF;
                  EXEC CONFERE_ERROS_NF @V_NF_CDFILIAL, @V_NRLANCTONF, @V_VRNOTAFISC;
   					EXEC GERA_CONTAPAGAR @V_NF_CDFILIAL, @V_CDFORNECED, @V_NRLANCTONF, 'F';
   					EXEC ATUALIZA_ESTOQUE @V_NF_CDFILIRECE, @V_NF_DTENTRSAID, @V_NF_DTENTRSAID, @V_NF_CDFILIAL, @V_NRLANCESTQ;
   				END;
            /*Gera os impostos, contas a receber e atualiza o estoque para notas de sada*/
            END
            ELSE BEGIN
            	EXEC IMPOSTO_SAIDA @V_NF_CDEMPRESA, @V_CDINSCESTA, @V_NF_CDTIPOOPER, @V_CDCLIENTE,
            		                @V_NF_CDFILIAL,  @V_NRLANCTONF, @V_NF_DTENTRSAID, @V_NRLANCESTQ,
                  	             NULL, @V_VRNOTAFISC OUTPUT;
               UPDATE NOTAFISCAL
               	SET VRNOTAFISC = @V_VRNOTAFISC
                WHERE CDFILIAL   = @V_NF_CDFILIAL
                  AND NRLANCTONF = @V_NRLANCTONF;

               EXEC APURAC_VENC @V_NF_CDFILIAL, @V_CDCLIENTE, @V_NRLANCTONF;
               EXEC ATUALIZA_ESTOQUE @V_NF_CDFILIEMIT, @V_NF_DTENTRSAID, @V_NF_DTENTRSAID, @V_NF_CDFILIAL, @V_NRLANCESTQ;

               SET @V_CDFILIMOVI = @V_NF_CDFILIEMIT;
               SET @V_IRREG_EST  = '0';
               IF @V_IDCTRLESTQ = 'S' BEGIN
                  SELECT @V_COUNTIRREG = COUNT(*)
                    FROM MOVILOTE M LEFT JOIN PRODFILI F ON  (M.CDPRODUTO = F.CDPRODUTO)
                    													AND (M.CDFILIAL  = F.CDFILIAL ),
                         PRODUTO P, USR_ITEMPRODUTO S
                   WHERE M.NRMOVILOTE = @V_NF_CDFILIAL+@V_NRLANCESTQ
                     AND M.CDFILIAL   = @V_CDFILIMOVI
                     AND P.CDPRODUTO  = M.CDPRODUTO
                     AND S.CDPRODUTO  = P.CDARVPROD
                     AND ISNULL(M.CDALMOXARIFE,' ') = ISNULL(S.CDALMOXARIFE, ' ')
                     AND ISNULL(M.CDLOCALESTOQ,' ') = ISNULL(S.CDLOCALESTOQ, ' ')
                     AND ISNULL(F.IDCNTRESTOQ,'S')  = 'S';
                  IF @V_COUNTIRREG > 0 BEGIN
                     SET @V_IRREG_EST = '1';
                     DECLARE C_CANCE CURSOR FOR SELECT DISTINCT ISNULL(P.CDARVPROD,'') AS PRODUTO
      			  		   FROM MOVILOTE M LEFT JOIN PRODUTO P  ON (M.CDPRODUTO = P.CDPRODUTO)
                         					 LEFT JOIN PRODFILI F ON (M.CDFILIAL  = F.CDFILIAL),
                        	  USR_ITEMPRODUTO S
                       WHERE (NRMOVILOTE  = @V_NF_CDFILIAL+@V_NRLANCESTQ)
                         AND (M.CDFILIAL   = @V_CDFILIMOVI)
                         AND (M.CDPRODUTO  = F.CDPRODUTO)
                         AND (S.CDPRODUTO  = P.CDARVPROD)
                         AND (ISNULL(M.CDALMOXARIFE,' ') = ISNULL(S.CDALMOXARIFE, ' '))
                         AND (ISNULL(M.CDLOCALESTOQ,' ') = ISNULL(S.CDLOCALESTOQ, ' '))
                         AND (ISNULL(F.IDCNTRESTOQ, 'S') = 'S');

                     SET @V_PRIPROD = '0';
                     OPEN C_CANCE;
   						FETCH NEXT FROM C_CANCE INTO @V_CANPROD;

   						WHILE (@@FETCH_STATUS = 0) BEGIN
                        IF @V_PRIPROD = '0' BEGIN
                           SET @V_NFLOG = @V_NFLOG + 'Lan. geraria irregularidade estoque para produtos ';
                           SET @V_PRIPROD = '1';
                        END;
                        SET @V_NFLOG = @V_NFLOG + @V_CANPROD+'.* ';
                        FETCH NEXT FROM C_CANCE INTO @V_CANPROD;
                     END;
                     CLOSE C_CANCE;
   						DEALLOCATE C_CANCE;

                		UPDATE USR_NOTAFISCAL
                        SET DSOBSERVERROS = DSOBSERVERROS + @V_NFLOG
                      WHERE CDCHAVE = @V_NF_CDCHAVE;
                      EXEC DELETA_NF @V_NF_CDFILIAL, @V_NRLANCTONF;
                      EXEC ATUALIZA_ESTOQUE @V_CDFILIMOVI, @V_NF_DTENTRSAID, @V_NF_DTENTRSAID, @V_NF_CDFILIAL, @V_NRLANCESTQ;
                      UPDATE USR_NOTAFISCAL
                         SET DTIMPORTA = NULL
                       WHERE CDCHAVE = @V_NF_CDCHAVE;
                  END;
               END;
            END;
             /*Grava a data de importao na tabela de controle*/
            IF @V_IRREG_EST = '0' BEGIN
               UPDATE USR_NOTAFISCAL
                  SET DTIMPORTA = GETDATE()
                WHERE CDCHAVE = @V_NF_CDCHAVE;
            END;
         END;
      END;

      FETCH NEXT FROM C_NF INTO @V_NF_CDCHAVE,    @V_NF_CDFILIAL,  @V_NF_CDEMPRESA,    @V_NF_NRINSJURNF,
   								     @V_NF_NRNOTAFISC, @V_NF_DTEMISSAO, @V_NF_DTENTRSAID,   @V_NF_IDENTRSAIDOP,
   								     @V_NF_CDTIPOOPER, @V_NF_CDSERIE,   @V_NF_CDMODDOCFISC, @V_NF_CDFILIEMIT,
                                @V_NF_CDFILIRECE, @V_NF_DTIMPORTA, @V_NF_DSOBSERVERROS;

   END;

   CLOSE C_NF;
   DEALLOCATE C_NF;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'SES_IMPORTA_NOTAFISCAL','5.11.000';
GO                                                
